from typing import List
from rdflib import Graph
import logging
from multiprocessing import Pool

from mapping.parsers.base import Config, MappingParser

logger = logging.getLogger(__name__)
logger.setLevel(logging.DEBUG)


class Dispatcher:
    output_file: str
    process_num: int
    processes: List[MappingParser]

    def __init__(self, output_file: str, process_num: int = Config.process_num):
        self.output_file = output_file
        self.process_num = process_num
        self.processes = []

    def add_parser(self, parser: MappingParser) -> None:
        """
        Add a parser to the pool of parsers
        :param parser: the parser class to add, should be a subclass of MappingParser
        """
        self.processes.append(parser)

    def _run_process(self, parser: MappingParser) -> Graph:
        """
        Helper method to run a single process on a parser
        :param parser: the parser to run
        :return: the graph generated by the parser
        """
        return parser.parse(Config.input_file)

    def run(self):
        """
        run all processes in parallel, capped by the number of processes, and if any still left, keep running till all done
        """
        if Config.process_num == 1:
            final_graph = Graph()
            for process in self.processes:
                print(f"Running {process.__class__.__name__}")
                graph = process.parse(Config.input_file)
                final_graph += graph
        else:
            final_graph = Graph()
            with Pool(self.process_num) as p:
                processes = [p.apply_async(self._run_process, args=(process,)) for process in self.processes]
                # Wait for all Future objects to finish
                for future in processes:
                    final_graph += future.get()
        final_graph.serialize(destination=self.output_file, format=Config.output_format, encoding="utf-8")
